package com.bria.common.controller.calllog.db

import android.arch.persistence.room.*
import io.reactivex.Flowable
import io.reactivex.Single

/**
 * Note, all Rx operations of this DAO always work on IO thread because of ROOM design
 */
@Dao
interface CallLogDao {
    @Insert(onConflict = OnConflictStrategy.REPLACE)
    fun put(callLogEntity: CallLogEntity) : Long

    @Query("SELECT * FROM calllog WHERE id IS :id")
    fun get(id: Long): Flowable<CallLogEntity>

    @Delete
    fun delete(vararg callLogEntity: CallLogEntity)

    @Query("DELETE FROM calllog WHERE callType IS :callType")
    fun delete(callType: CallType)

    @Query("DELETE FROM calllog")
    fun deleteAll()

    @Query("SELECT * FROM calllog ORDER BY date DESC")
    fun getAll(): Flowable<List<CallLogEntity>>

    @Query("SELECT COUNT(id) FROM calllog")
    fun getCount(): Single<Int>
    // todo
}
