package com.bria.common.controller.calllog.db

import android.arch.persistence.room.Database
import android.arch.persistence.room.Room
import android.arch.persistence.room.RoomDatabase
import android.arch.persistence.room.TypeConverters
import android.content.Context
import com.bria.common.controller.calllog.db.convertors.CallTypeConverter


@Database(entities = [CallLogEntity::class], version = 1, exportSchema = false)
@TypeConverters(CallTypeConverter::class)
abstract class CallLogDatabase : RoomDatabase() {
    abstract fun callLogDao(): CallLogDao

    companion object {
        @Volatile private var INSTANCE: CallLogDatabase? = null

        fun get(context: Context): CallLogDatabase =
                INSTANCE ?: synchronized(this) {
                    INSTANCE ?: buildDatabase(context).also { INSTANCE = it }
                }

        private fun buildDatabase(context: Context) = Room
                .databaseBuilder(context.applicationContext, CallLogDatabase::class.java, "calllog.db")
                //.addMigrations(MIGRATION_15_16)
                .build()

        fun destroy() {
            INSTANCE?.close()
            INSTANCE = null
        }

//        val MIGRATION_15_16: Migration = object : Migration(15, 16) {
//            override fun migrate(database: SupportSQLiteDatabase) {
//                // todo
//            }
//        }
    }
}
