package com.bria.common.controller.calllog.db

import android.arch.persistence.room.ColumnInfo
import android.arch.persistence.room.Entity
import android.arch.persistence.room.PrimaryKey

@Entity(tableName = "calllog")
data class CallLogEntity(
        @ColumnInfo(name = "number") var number: String = "",
        @ColumnInfo(name = "numberType") var numberType: String = "",
        @ColumnInfo(name = "callType") var callType: CallType = CallType.INCOMING,
        @ColumnInfo(name = "date") var date: Long = System.currentTimeMillis(),
        @ColumnInfo(name = "durationSeconds") var durationSeconds: Int = 0,
        @ColumnInfo(name = "contactId") var contactId: String = "",
        @ColumnInfo(name = "displayName") var displayName: String = "",
        @ColumnInfo(name = "provisioningUser") var provisioningUser: String = "",
        @ColumnInfo(name = "accountNickname") var accountNickname: String = "",
        @ColumnInfo(name = "accountUsername") var accountUsername: String = "",
        @ColumnInfo(name = "accountDomain") var accountDomain: String = "",
        @ColumnInfo(name = "remoteDomain") var remoteDomain: String = "",
        @ColumnInfo(name = "remoteName") var remoteName: String = "",
        @ColumnInfo(name = "recordPath") var recordPath: String = "",
        @ColumnInfo(name = "forwardedTo") var forwardedTo: String = "",
        @ColumnInfo(name = "hostedCollab") var hostedCollab: Boolean = false,
        @ColumnInfo(name = "new") var new: Boolean = true
    ) {
    @PrimaryKey(autoGenerate = true)
    @ColumnInfo(name = "id") var id: Long = 0
}
