package com.bria.common.controller.collaboration.rx.entities

import com.counterpath.sdk.pb.VccsConference.VideoLayout
import com.counterpath.sdk.pb.VccsConference.VideoLayout.Focus

/**
 * Conference config object, holds the setting values.
 * To actually persist any of these (ordered) values, you need to set
 * the corresponding flags in an accompanying [ConferenceConfigFlags] object.
 */
data class ConferenceConfigValues(
        var participantPin: String = "",
        var moderatorPin: String = "",
        var videoLayout: VideoLayout = Focus,
        var frameRate: Int = 10,
        var isModerated: Boolean = false,
        var overrunMinutes: Int = 0,
        var dropBoxToken: String = "",
        var sendSummaryEmail: Boolean = true,
        var recordAudioOnly: Boolean = false,
        var autoRecord: Boolean = false
)
