package com.bria.common.controller.collaboration.rx.entities

import com.counterpath.sdk.SipVccsAccountApi

/**
 * A data holder for VCCS links.
 */
data class LinkInfo(var original: String = "", private val parseResult: SipVccsAccountApi.CrackVCCSURLResult? = null) {
    var groupName: String = ""
    var serverName: String = ""
    var webSocketUrl: String = ""
    var conferenceCode: String = ""
    var portNumber: Int = 0

    init {
        parseResult?.let {
            groupName = it.outGroupName ?: ""
            serverName = it.outServerName ?: ""
            webSocketUrl = it.outWebSocketURL ?: ""
            conferenceCode = it.outSubscriptionCode ?: ""
            portNumber = it.outPortNumber
        }
    }
}
