package com.bria.common.controller.collaboration.rx.entities

import com.counterpath.sdk.SipVccsConferenceApi

/**
 * A helper object containing all parameters needed to make a successful subscription request.
 *
 * Optional parameters (you must pick one to fill):
 * ```
 * [SubscriptionRequest.bridge] Optional bridge number to subscribe to, defaults to empty string
 * [SubscriptionRequest.conferenceCode] Optional conference code to subscribe to, defaults to empty string
 * ```
 *
 * @param accountId The account to use
 * @param sipAor Local user's SIP AOR
 * @param capabilities Conferencing capabilities (bitmask), see [SipVccsConferenceApi] constants
 * @param appId A unique app identifier
 * @param pinCode Participant PIN for the conference, defaults to empty
 */
class SubscriptionRequest(val accountId: Int = 0, val sipAor: String = "", val capabilities: Int = 0, val appId: String = "", val pinCode: String = "", val bridgeSip: String? = "", val subscriptionCode: String = "", val sipAddess: String = "", val participantType: Int = 1) {
}
