package com.bria.common.controller.contacts.buddy

import android.text.TextUtils
import com.bria.common.controller.contacts.ContactsSortBy

class BuddyComparator(private val contactSortBy: ContactsSortBy) : kotlin.Comparator<Buddy> {
    override fun compare(l: Buddy?, r: Buddy?): Int {
        if (l == null) {
            if (r == null) {
                return 0
            }

            // left should be at the end

            return 1
        }

        if (r == null) {
            // r is at the end, thus we return -1

            return -1
        }

        val lString = getNameForComparison(l)
        val rString = getNameForComparison(r)

        val result = lString.compareTo(rString, ignoreCase = true)

        return result
    }

    private fun getNameForComparison(buddy: Buddy): String {
        var retVal: String
        if (contactSortBy == ContactsSortBy.FirstName) {
            retVal = buddy.firstName
            if (TextUtils.isEmpty(retVal)) {
                retVal = buddy.lastName
            } else {
                retVal += " " + buddy.lastName
            }
        } else {
            retVal = buddy.lastName
            if (TextUtils.isEmpty(retVal)) {
                retVal = buddy.firstName
            } else {
                retVal += "," + buddy.firstName
            }
        }

        if (TextUtils.isEmpty(retVal)) {
            retVal = buddy.displayName
        }

        if (retVal == null) {
            retVal = ""
        }

        return retVal
    }
}
