package com.bria.common.controller.contacts.buddy.repository

import android.arch.persistence.room.Dao
import android.arch.persistence.room.Delete
import android.arch.persistence.room.Insert
import android.arch.persistence.room.OnConflictStrategy.REPLACE
import android.arch.persistence.room.Query


@Dao
interface BuddyDao {
    @Insert(onConflict = REPLACE)
    fun insert(buddy: BuddyEntity)

    @Delete
    fun delete(buddy: BuddyEntity)

    @Query("SELECT * FROM buddies")
    fun getAllBuddies(): List<BuddyEntity>

    @Query("SELECT * FROM buddies WHERE key IS :key")
    fun getBuddyByKey(key: String): List<BuddyEntity>

    @Query("SELECT * FROM buddies WHERE (firstName || ' ' || lastName) LIKE ('%' || :searchString || '%') OR (lastName || ' ' || firstName) LIKE ('%' || :searchString || '%')")
    fun getAllBuddiesWith(searchString: String): List<BuddyEntity>
}
