package com.bria.common.controller.contacts.buddy.repository

import com.bria.common.controller.contacts.buddy.Buddy
import io.reactivex.Observable


interface BuddyRepository {
    fun addBuddyEntity(buddy : BuddyEntity)

    fun addBuddy(buddy : Buddy)

    fun deleteBuddy(buddy: BuddyEntity)

    fun removeBuddyByKey(buddyKey : String)

    fun getBuddies() : List<BuddyEntity>

    fun getBuddyEntityByKey(key : String) : BuddyEntity?

    fun getBuddyByKey(key : String) : Buddy?

    fun getObservableOnBuddyListChanged(): Observable<Any>

    fun filterBuddiesBy(searchString: String): List<BuddyEntity>
    fun destroy()

}
