package com.bria.common.controller.contacts.buddy.repository

import android.arch.persistence.room.*
import com.bria.common.controller.contacts.buddy.VCard

@Entity(tableName = "phones",
        foreignKeys = [(ForeignKey(entity = BuddyEntity::class, parentColumns = ["key"], childColumns = ["buddyKey"]))]
                , indices = [Index("buddyKey")])
data class PhoneEntity(
        @ColumnInfo(name = "buddyKey") val buddyKey : String,
        @ColumnInfo(name = "phoneType") val phoneType : VCard.EPhoneType,
        @ColumnInfo(name = "phoneNumber") val phoneNumber: String,
        @ColumnInfo(name = "preferred") val preferred: Boolean
        ) {

    @ColumnInfo(name = "id")
    @PrimaryKey(autoGenerate = true) var id: Long = 0
}
