package com.bria.common.controller.im.refactoring.dataprovider

import android.support.v7.util.DiffUtil

import com.bria.common.uireusable.datatypes.MessageListItemData

class InstantMessageDiffUtils(private val mOldData: List<MessageListItemData>, private val mNewData: List<MessageListItemData>) : DiffUtil.Callback() {

    override fun getOldListSize(): Int = mOldData.size

    override fun getNewListSize(): Int = mNewData.size

    override fun areItemsTheSame(oldItemPosition: Int, newItemPosition: Int): Boolean {
        val oldIm = mOldData[oldItemPosition]
        val newIm = mNewData[newItemPosition]
        return oldIm.id == newIm.id && oldIm.conversationId == newIm.conversationId
    }
    override fun areContentsTheSame(oldItemPosition: Int, newItemPosition: Int): Boolean {
        val oldIm = mOldData[oldItemPosition]
        val newIm = mNewData[newItemPosition]
        return oldIm.conversationId == newIm.conversationId
                && oldIm.id == newIm.id
                && oldIm.containsArticle() == newIm.containsArticle()
                && oldIm.buddyVisible == newIm.buddyVisible
                && oldIm.selected == newIm.selected
                && oldIm.error == newIm.error
                && oldIm.status == newIm.status
                && oldIm.fileTransferProgress == newIm.fileTransferProgress

    }
}
