package com.bria.common.controller.im.refactoring.db.entities

import com.bria.common.R
import com.bria.common.controller.im.refactoring.db.entities.ImStatusData.*
import com.bria.common.controller.im.refactoring.roomdb.entities.Message
import com.bria.common.uireusable.datatypes.MessageListItemData
import java.io.File

//The ugly stuff

fun InstantMessageData.moveToSentStatus() {
    this.fileTransferState = 100
    this.status = this.getStatusPrefix() or OUTGOING_FLAG_SENT
}

fun InstantMessageData.moveToNotExists() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or OUTGOING_FLAG_NOT_EXISTS
}

fun InstantMessageData.moveToFailToSend() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or OUTGOING_FLAG_FAIL_TO_SEND
}

fun InstantMessageData.moveToFailToReceive() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or (this.status and ImStatusData.INCOMING_FLAG_READ) or INCOMING_FLAG_FAILED_TO_RECEIVE
}

fun InstantMessageData.moveToLocalCancel() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or OUTGOING_FLAG_LOCAL_CANCEL
}

fun InstantMessageData.moveToRemoteCancel() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or OUTGOING_FLAG_REMOTE_CANCEL
}

fun InstantMessageData.moveToRetried() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or OUTGOING_FLAG_FAIL_TO_SEND_RETRIED
}

fun InstantMessageData.moveToUnknownError() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or OUTGOING_FLAG_UNKNOWN_ERROR
}

fun InstantMessageData.moveToShowInfo() {
    this.fileTransferState = 0
    this.status = this.getStatusPrefix() or INCOMING_FLAG_WAITING_FOR_USER_PROMPT_SHOW_INFO or (this.status and ImStatusData.INCOMING_FLAG_READ)
}

fun InstantMessageData.moveToProgress() {
    if (this.isIncomingFT()) {
        this.status = this.getStatusPrefix() or INCOMING_FLAG_RECEIVING or (this.status and ImStatusData.INCOMING_FLAG_READ)
    } else {
        this.status = this.getStatusPrefix() or OUTGOING_FLAG_SENDING
    }

}

fun InstantMessageData.getStatusDescription(): String = this.status.getStatusDescription()
fun InstantMessageData.getStatusPrefix(): Int = this.status and 0xFF00
fun InstantMessageData.isInProgress(): Boolean = isOutgoingTransferSending() || isIncomingReceiving()
fun InstantMessageData.isIncomingFT(): Boolean = this.getStatusPrefix() in
        intArrayOf(INCOMING_FT_PREFIX, INCOMING_IMAGE_TRANSFER_PREFIX)
fun InstantMessageData.isOutgoingFT(): Boolean = this.getStatusPrefix() in
        intArrayOf(OUTGOING_FT_PREFIX, OUTGOING_IMAGE_TRANSFER_PREFIX)
fun InstantMessageData.isOutgoingImage(): Boolean = this.getStatusPrefix() == OUTGOING_IMAGE_TRANSFER_PREFIX

fun InstantMessageData.getStatusWithoutPrefix(): Int = this.status and if (this.isIncomingFT()) 0x00FE else 0x00FF // removing IsRead Flag
fun InstantMessageData.isOutgoingTransferSending(): Boolean = this.getStatusWithoutPrefix() == OUTGOING_FLAG_SENDING
fun InstantMessageData.isIncomingReceiving(): Boolean = this.getStatusWithoutPrefix() == INCOMING_FLAG_RECEIVING
fun InstantMessageData.isTransfer(): Boolean =
        this.getStatusPrefix() in intArrayOf(INCOMING_FT_PREFIX, INCOMING_IMAGE_TRANSFER_PREFIX, OUTGOING_FT_PREFIX, OUTGOING_IMAGE_TRANSFER_PREFIX)
fun InstantMessageData.isOutgoingPending() : Boolean = this.getStatusWithoutPrefix() == OUTGOING_FLAG_PENDING

fun InstantMessageData.isIncomingReceived(): Boolean = this.isIncomingFT()
        && (this.getStatusWithoutPrefix() == INCOMING_FLAG_RECEIVED || this.getStatusWithoutPrefix() == INCOMING_FLAG_RECEIVED_CHECKED)

fun InstantMessageData.isLocalCancel() : Boolean = this.getStatusWithoutPrefix() == OUTGOING_FLAG_LOCAL_CANCEL
        || this.getStatusWithoutPrefix() == INCOMING_FLAG_LOCAL_CANCEL
fun InstantMessageData.isTransferValidForForwarding() : Boolean = isTransfer() && (isOutgoing() || isIncomingReceived())

fun InstantMessageData.markRead() {
    if (this.isIncomingFT()) {
        this.status = this.status or ImStatusData.INCOMING_FLAG_READ
    } else {
        if (this.status == ImStatusData.INCOMING_UNREAD || this.status == ImStatusData.INCOMING_COLLAB_UNREAD) {
            this.status = ImStatusData.INCOMING_READ
        }
    }
}

fun InstantMessageData.isFileTransferUnread() : Boolean = this.isIncomingFT() && ((this.status and ImStatusData.INCOMING_FLAG_READ) == 0)

fun Message.getStatusPrefix(): Int = this.status and 0xFF00

fun Message.isTransfer(): Boolean =
        this.getStatusPrefix() in intArrayOf(INCOMING_FT_PREFIX, INCOMING_IMAGE_TRANSFER_PREFIX, OUTGOING_FT_PREFIX, OUTGOING_IMAGE_TRANSFER_PREFIX)

fun Message.isIncomingFT(): Boolean = this.getStatusPrefix() in intArrayOf(INCOMING_FT_PREFIX, INCOMING_IMAGE_TRANSFER_PREFIX)

fun Message.isFileTransferUnread() : Boolean = this.isIncomingFT() && ((this.status and ImStatusData.INCOMING_FLAG_READ) == 0)

fun MessageListItemData.isFileTransferUnread() : Boolean = this.isIncomingFT() && ((this.status and ImStatusData.INCOMING_FLAG_READ) == 0)

fun MessageListItemData.isTransfer(): Boolean =
        this.getStatusPrefix() in intArrayOf(INCOMING_FT_PREFIX, INCOMING_IMAGE_TRANSFER_PREFIX, OUTGOING_FT_PREFIX, OUTGOING_IMAGE_TRANSFER_PREFIX)


fun MessageListItemData.isIncomingFT(): Boolean = this.getStatusPrefix() in intArrayOf(INCOMING_FT_PREFIX, INCOMING_IMAGE_TRANSFER_PREFIX)

fun MessageListItemData.isOutgoingFT(): Boolean = this.getStatusPrefix() in intArrayOf(OUTGOING_FT_PREFIX, OUTGOING_IMAGE_TRANSFER_PREFIX)

fun MessageListItemData.isOutgoingFile(): Boolean = this.getStatusPrefix() == OUTGOING_FT_PREFIX
fun MessageListItemData.isIncomingFile(): Boolean = this.getStatusPrefix() == INCOMING_FT_PREFIX
fun MessageListItemData.isOutgoingImage(): Boolean = this.getStatusPrefix() == OUTGOING_IMAGE_TRANSFER_PREFIX
fun MessageListItemData.isIncomingImage(): Boolean = this.getStatusPrefix() == INCOMING_IMAGE_TRANSFER_PREFIX


fun MessageListItemData.isIncomingReceived(): Boolean = this.isIncomingFT()
        && (this.getStatusWithoutPrefix() == INCOMING_FLAG_RECEIVED || this.getStatusWithoutPrefix() == INCOMING_FLAG_RECEIVED_CHECKED)
fun MessageListItemData.isIncomingReceiving(): Boolean = this.isIncomingFT() && this.getStatusWithoutPrefix() == INCOMING_FLAG_RECEIVING
fun MessageListItemData.isOutgoingTransferPending(): Boolean = this.isOutgoingFT() && this.getStatusWithoutPrefix() == OUTGOING_FLAG_PENDING
fun MessageListItemData.isOutgoingTransferSending(): Boolean = this.isOutgoingFT() && this.getStatusWithoutPrefix() == OUTGOING_FLAG_SENDING
fun MessageListItemData.isOutgoingTransferSent(): Boolean = this.isOutgoingFT() && this.getStatusWithoutPrefix() == OUTGOING_FLAG_SENT
fun MessageListItemData.getStatusPrefix(): Int = this.status and 0xFF00
fun MessageListItemData.getStatusWithoutPrefix(): Int = this.status and if (this.isIncomingFT()) 0x00FE else 0x00FF // removing IsRead Flag
fun MessageListItemData.isFileTransferMessageIsNotChecked(): Boolean = this.status == INCOMING_FT_RECEIVED_UNREAD
fun MessageListItemData.shouldShowImage(): Boolean = this.getStatusPrefix() == OUTGOING_IMAGE_TRANSFER_PREFIX
        || this.isFileTransferMessageIsNotChecked()

fun MessageListItemData.isInProgress(): Boolean = isOutgoingTransferSending() || isIncomingReceiving()
fun MessageListItemData.getStatusDescription(): String = this.status.getStatusDescription()

fun MessageListItemData.isOutgoingFailToSend() = this.isOutgoingFT()
        && this.getStatusWithoutPrefix() in intArrayOf(OUTGOING_FLAG_FAIL_TO_SEND, OUTGOING_FLAG_FAIL_TO_SEND_RETRIED)
fun MessageListItemData.isOutgoingUnknown() = this.isOutgoingFT() && this.getStatusWithoutPrefix() == OUTGOING_FLAG_UNKNOWN_ERROR
fun MessageListItemData.isRejected() = this.isOutgoingFT() && this.getStatusWithoutPrefix() == OUTGOING_FLAG_REMOTE_CANCEL
fun MessageListItemData.isImageTransfer() = this.getStatusPrefix() in intArrayOf(INCOMING_IMAGE_TRANSFER_PREFIX, OUTGOING_IMAGE_TRANSFER_PREFIX)


// @formatter:off
fun MessageListItemData.isStatusIconVisible() =
        (this.isIncomingFT() && this.getStatusWithoutPrefix() in intArrayOf(
                INCOMING_FLAG_RECEIVING))
        || (this.isOutgoingFile() && this.getStatusWithoutPrefix() in intArrayOf(
                OUTGOING_FLAG_PENDING,
                OUTGOING_FLAG_SENDING,
                OUTGOING_FLAG_FAIL_TO_SEND,
                OUTGOING_FLAG_LOCAL_CANCEL,
                OUTGOING_FLAG_REMOTE_CANCEL,
                OUTGOING_FLAG_NOT_EXISTS,
                OUTGOING_FLAG_UNKNOWN_ERROR))
        || (this.isOutgoingImage() && this.getStatusWithoutPrefix() in intArrayOf(
                OUTGOING_FLAG_PENDING,
                OUTGOING_FLAG_SENDING,
                OUTGOING_FLAG_FAIL_TO_SEND,
                OUTGOING_FLAG_LOCAL_CANCEL,
                OUTGOING_FLAG_REMOTE_CANCEL,
                OUTGOING_FLAG_NOT_EXISTS,
                OUTGOING_FLAG_UNKNOWN_ERROR
        ))

fun MessageListItemData.isStatusTextVisible() =
        (this.isIncomingFile() && this.getStatusWithoutPrefix() in intArrayOf(
                INCOMING_FLAG_RECEIVING,
                INCOMING_FLAG_RECEIVED,
                INCOMING_FLAG_REJECTED,
                INCOMING_FLAG_LOCAL_CANCEL,
                INCOMING_FLAG_REMOTE_CANCEL,
                INCOMING_FLAG_UNKNOWN_ERROR,
                INCOMING_FLAG_RECEIVED_CHECKED))
        || (this.isIncomingImage() && this.getStatusWithoutPrefix() in intArrayOf())
                || (this.isOutgoingFile() && this.getStatusWithoutPrefix() in intArrayOf(
                OUTGOING_FLAG_PENDING,
                OUTGOING_FLAG_SENDING,
                OUTGOING_FLAG_FAIL_TO_SEND,
                OUTGOING_FLAG_SENT,
                OUTGOING_FLAG_LOCAL_CANCEL,
                OUTGOING_FLAG_REMOTE_CANCEL,
                OUTGOING_FLAG_NOT_EXISTS,
                OUTGOING_FLAG_UNKNOWN_ERROR))
        || (this.isOutgoingImage() && this.getStatusWithoutPrefix() in intArrayOf(
                OUTGOING_FLAG_PENDING,
                OUTGOING_FLAG_FAIL_TO_SEND
        ))


fun MessageListItemData.getStatusIcon() : Int {
    if (this.isIncomingFT()) {
        return when (this.getStatusWithoutPrefix()) {
            INCOMING_FLAG_RECEIVING -> R.drawable.ic_cancel_transfer
            else -> R.drawable.ic_cancel_transfer
        }
    } else if (this.isOutgoingImage()) {
        return when (this.getStatusWithoutPrefix()) {
            OUTGOING_FLAG_PENDING -> R.drawable.ic_waiting_file
            OUTGOING_FLAG_SENDING -> R.drawable.ic_cancel_transfer
            OUTGOING_FLAG_FAIL_TO_SEND,
            OUTGOING_FLAG_UNKNOWN_ERROR -> R.drawable.ic_retry_transfer
            OUTGOING_FLAG_LOCAL_CANCEL,
            OUTGOING_FLAG_REMOTE_CANCEL -> R.drawable.ic_transfer_declined
            OUTGOING_FLAG_NOT_EXISTS -> R.drawable.ic_transfer_declined
            else -> R.drawable.ic_cancel_transfer
        }
    } else if (this.isOutgoingFile()) {
        return when (this.getStatusWithoutPrefix()) {
            OUTGOING_FLAG_PENDING -> R.drawable.ic_waiting_file
            OUTGOING_FLAG_SENDING -> R.drawable.ic_cancel_transfer
            OUTGOING_FLAG_FAIL_TO_SEND,
            OUTGOING_FLAG_UNKNOWN_ERROR -> R.drawable.ic_retry_transfer
            OUTGOING_FLAG_SENT -> R.drawable.ic_accept_file
            OUTGOING_FLAG_LOCAL_CANCEL,
            OUTGOING_FLAG_REMOTE_CANCEL -> R.drawable.ic_transfer_declined
            OUTGOING_FLAG_NOT_EXISTS -> R.drawable.ic_transfer_declined
            else -> R.drawable.ic_cancel_transfer
        }
    }
    return R.drawable.ic_accept_file
}

fun MessageListItemData.isProgressBarVisible(): Boolean =
        (this.isIncomingFT() && this.getStatusWithoutPrefix() == INCOMING_FLAG_RECEIVING)
        || (this.isIncomingImage() && this.getStatusWithoutPrefix() in intArrayOf(INCOMING_FLAG_RECEIVING))
        || (this.isOutgoingFT() && this.getStatusWithoutPrefix() == OUTGOING_FLAG_SENDING)
        || (this.isOutgoingImage() && this.getStatusWithoutPrefix() in intArrayOf(OUTGOING_FLAG_SENDING))


fun MessageListItemData.getStatusText(): String {
    if (this.isIncomingFT()) {
        return when (this.getStatusWithoutPrefix()) {
            INCOMING_FLAG_RECEIVING -> this.context.getString(R.string.tCancel)
            INCOMING_FLAG_RECEIVED,
            INCOMING_FLAG_RECEIVED_CHECKED -> this.context.getString(R.string.tTransferComplete)
            INCOMING_FLAG_REJECTED -> this.context.getString(R.string.tTransferRejected)
            INCOMING_FLAG_LOCAL_CANCEL,
            INCOMING_FLAG_REMOTE_CANCEL,
            INCOMING_FLAG_UNKNOWN_ERROR -> this.context.getString(R.string.tTransferRejected)
            else -> ""
        }
    } else if (this.isOutgoingFT()) {
        return when (this.getStatusWithoutPrefix()) {
            OUTGOING_FLAG_PENDING -> this.context.getString(R.string.tWaitingStatus)
            OUTGOING_FLAG_SENDING -> this.context.getString(R.string.tCancel)
            OUTGOING_FLAG_FAIL_TO_SEND,
            OUTGOING_FLAG_UNKNOWN_ERROR -> this.context.getString(R.string.tRetryTransfer)
            OUTGOING_FLAG_SENT -> this.context.getString(R.string.tTransferComplete)
            OUTGOING_FLAG_LOCAL_CANCEL,
            OUTGOING_FLAG_REMOTE_CANCEL -> this.context.getString(R.string.tTransferDeclined)
            OUTGOING_FLAG_NOT_EXISTS -> this.context.getString(R.string.tRetryTransfer)
            else -> ""
        }
    }
    return ""
}

fun MessageListItemData.isBottomStatusVisible() =
        (this.isIncomingFT() && this.getStatusWithoutPrefix() in intArrayOf(
                INCOMING_FLAG_FAILED_TO_RECEIVE))
        || (this.isIncomingImage() && this.getStatusWithoutPrefix() in intArrayOf(INCOMING_FLAG_RECEIVING))
        || (this.isOutgoingFT() && this.getStatusWithoutPrefix() in intArrayOf(
                OUTGOING_FLAG_FAIL_TO_SEND,
                OUTGOING_FLAG_FAIL_TO_SEND_RETRIED,
                OUTGOING_FLAG_UNKNOWN_ERROR))
        || (this.isOutgoingImage() && this.getStatusWithoutPrefix() in intArrayOf(
                OUTGOING_FLAG_SENT,
                OUTGOING_FLAG_REMOTE_CANCEL,
                OUTGOING_FLAG_LOCAL_CANCEL,
                OUTGOING_FLAG_FAIL_TO_SEND,
                OUTGOING_FLAG_FAIL_TO_SEND_RETRIED))

fun MessageListItemData.getStatusBottomText() : String {
    if (this.isIncomingFT()) {
        return when (this.getStatusWithoutPrefix()) {
            INCOMING_FLAG_FAILED_TO_RECEIVE -> this.context.getString(R.string.tTransferFailed)
            else -> ""
        }
    } else if (this.isOutgoingFile()) {
        return when (this.getStatusWithoutPrefix()) {
            OUTGOING_FLAG_FAIL_TO_SEND,
            OUTGOING_FLAG_UNKNOWN_ERROR,
            OUTGOING_FLAG_FAIL_TO_SEND_RETRIED -> this.context.getString(R.string.tTransferFailed)
            else -> ""
        }
    } else if (this.isOutgoingImage()) {
        return when (this.getStatusWithoutPrefix()) {
            OUTGOING_FLAG_SENT -> this.context.getString(R.string.tTransferComplete)
            OUTGOING_FLAG_LOCAL_CANCEL,
            OUTGOING_FLAG_REMOTE_CANCEL -> this.context.getString(R.string.tTransferDeclined)
            OUTGOING_FLAG_FAIL_TO_SEND,
            OUTGOING_FLAG_UNKNOWN_ERROR,
            OUTGOING_FLAG_FAIL_TO_SEND_RETRIED -> this.context.getString(R.string.tTransferFailed)
            else -> ""
        }
    }
    return ""
}

fun MessageListItemData.getIconByFileType(): Int {
    return when (this.fileExtension?.toLowerCase()){
        "pdf" -> R.drawable.ic_filetype_pdf
        "doc", "docx" -> R.drawable.ic_filetype_word
        "xls", "xlsx" -> R.drawable.ic_filetype_excel
        else  -> R.drawable.ic_file_24dp
    }
}

fun InstantMessageData.isWaitingForUserPrompt() = this.isIncomingFT() && (this.getStatusWithoutPrefix() == INCOMING_FLAG_WAITING_FOR_USER_PROMPT
        || this.getStatusWithoutPrefix() == INCOMING_FLAG_WAITING_FOR_USER_PROMPT_SHOW_INFO)
// @formatter:on
fun MessageListItemData.isWaitingForUserPrompt() = this.isIncomingFT() && (this.getStatusWithoutPrefix() == INCOMING_FLAG_WAITING_FOR_USER_PROMPT
                || this.getStatusWithoutPrefix() == INCOMING_FLAG_WAITING_FOR_USER_PROMPT_SHOW_INFO)



fun MessageListItemData.isTransferActionInfoVisible() = this.isIncomingFT() && this.getStatusWithoutPrefix() == INCOMING_FLAG_WAITING_FOR_USER_PROMPT_SHOW_INFO

fun MessageListItemData.isAcceptDeclineVisible(): Boolean = this.isWaitingForUserPrompt()

fun MessageListItemData.isTimeVisible() = (this.isIncomingFT() && this.getStatusWithoutPrefix() in intArrayOf(
        INCOMING_FLAG_RECEIVED, INCOMING_FLAG_RECEIVED_CHECKED
)) || (this.isOutgoingFT() && this.getStatusWithoutPrefix() in intArrayOf(
        OUTGOING_FLAG_SENT
))

fun File.getDataType() : String {
    return when (this.extension) {
        "doc", "docx" -> "application/msword"
        "pdf" -> "application/pdf"
        "ppt", "pptx" -> "application/vnd.ms-powerpoint"
        "xls", "xlsx" -> "application/vnd.ms-excel"
        "zip", "rar" -> "application/zip"
        "rtf" -> "application/rtf"
        "wav", ".mp3" -> "audio/x-wav"
        "gif" -> "image/gif"
        "jpg", "jpeg", "png" ->  "image/jpeg"
        "txt" -> "text/plain"
        "3gp", "mpg", "mpeg", "mpe", "mp4", "avi" -> "video/*"
        else -> "*/*"
    }
}

private fun Int.getStatusDescription(): String {
    return when (this) {
        OUTGOING_PENDING -> "OUTGOING_PENDING"
        OUTGOING_SENT -> "OUTGOING_SENT"
        OUTGOING_SENDING_FAILED -> "OUTGOING_SENDING_FAILED"
        OUTGOING_DELIVERED -> "OUTGOING_DELIVERED"
        OUTGOING_NOT_DELIVERED -> "OUTGOING_NOT_DELIVERED"
        OUTGOING_SEEN -> "OUTGOING_SEEN"

        INCOMING_UNREAD -> "INCOMING_UNREAD"
        INCOMING_READ -> "INCOMING_READ"
        INCOMING_COLLAB_UNREAD -> "INCOMING_COLLAB_UNREAD"
        LOCAL -> "LOCAL"

        OUTGOING_FT_PENDING -> "OUTGOING_FT_PENDING"
        OUTGOING_FT_SENDING -> "OUTGOING_FT_SENDING"
        OUTGOING_FT_FAIL_TO_SEND_ONCE -> "OUTGOING_FT_FAIL_TO_SEND_ONCE"
        OUTGOING_FT_FAIL_TO_SEND_TWICE -> "OUTGOING_FT_FAIL_TO_SEND_TWICE"
        OUTGOING_FT_FAIL_TO_SEND -> "OUTGOING_FT_FAIL_TO_SEND"
        OUTGOING_FT_SENT -> "OUTGOING_FT_SENT"
        OUTGOING_FT_LOCAL_CANCEL -> "OUTGOING_FT_LOCAL_CANCEL"
        OUTGOING_FT_REMOTE_CANCEL -> "OUTGOING_FT_REMOTE_CANCEL"
        OUTGOING_FT_NOT_EXISTS -> "OUTGOING_FT_NOT_EXISTS"
        OUTGOING_FT_UNKNOWN_ERROR -> "OUTGOING_FT_UNKNOWN_ERROR"

        OUTGOING_IMAGE_TRANSFER_PENDING -> "OUTGOING_IMAGE_TRANSFER_PENDING"
        OUTGOING_IMAGE_TRANSFER_SENDING -> "OUTGOING_IMAGE_TRANSFER_SENDING"
        OUTGOING_IMAGE_TRANSFER_FAIL_TO_SENT_ONCE -> "OUTGOING_IMAGE_TRANSFER_FAIL_TO_SENT_ONCE"
        OUTGOING_IMAGE_TRANSFER_FAIL_TO_SENT_TWICE -> "OUTGOING_IMAGE_TRANSFER_FAIL_TO_SENT_TWICE"
        OUTGOING_IMAGE_TRANSFER_FAIL_TO_SEND -> "OUTGOING_IMAGE_TRANSFER_FAIL_TO_SEND"
        OUTGOING_IMAGE_TRANSFER_SENT -> "OUTGOING_IMAGE_TRANSFER_SENT"
        OUTGOING_IMAGE_TRANSFER_LOCAL_CANCEL -> "OUTGOING_IMAGE_TRANSFER_LOCAL_CANCEL"
        OUTGOING_IMAGE_TRANSFER_REMOTE_CANCEL -> "OUTGOING_IMAGE_TRANSFER_REMOTE_CANCEL"
        OUTGOING_IMAGE_TRANSFER_NOT_EXISTS -> "OUTGOING_IMAGE_TRANSFER_NOT_EXISTS"
        OUTGOING_IMAGE_TRANSFER_UNKNOWN_ERROR -> "OUTGOING_IMAGE_TRANSFER_UNKNOWN_ERROR"
        INCOMING_FT_WAITING_FOR_USER_PROMPT_UNREAD -> "INCOMING_FT_WAITING_FOR_USER_PROMPT_UNREAD"
        INCOMING_FT_WAITING_FOR_USER_PROMPT_READ -> "INCOMING_FT_WAITING_FOR_USER_PROMPT_READ"
        INCOMING_FT_WAITING_FOR_USER_PROMPT_SHOW_INFO_UNREAD -> "INCOMING_FT_WAITING_FOR_USER_PROMPT_SHOW_INFO_UNREAD"
        INCOMING_FT_WAITING_FOR_USER_PROMPT_SHOW_INFO_READ -> "INCOMING_FT_WAITING_FOR_USER_PROMPT_SHOW_INFO_READ"

        INCOMING_FT_RECEIVING_UNREAD -> "INCOMING_FT_RECEIVING_UNREAD"
        INCOMING_FT_RECEIVING_READ -> "INCOMING_FT_RECEIVING_READ"
        INCOMING_FT_FAILED_TO_RECEIVE_UNREAD -> "INCOMING_FT_FAILED_TO_RECEIVE_UNREAD"
        INCOMING_FT_FAILED_TO_RECEIVE_READ -> "INCOMING_FT_FAILED_TO_RECEIVE_READ"
        INCOMING_FT_RECEIVED_UNREAD -> "INCOMING_FT_RECEIVED_UNREAD"
        INCOMING_FT_RECEIVED_READ -> "INCOMING_FT_RECEIVED_READ"
        INCOMING_FT_REJECTED_READ -> "INCOMING_FT_REJECTED_READ"
        INCOMING_FT_LOCAL_CANCEL_UNREAD -> "INCOMING_FT_LOCAL_CANCEL_UNREAD"
        INCOMING_FT_LOCAL_CANCEL_READ -> "INCOMING_FT_LOCAL_CANCEL_READ"
        INCOMING_FT_REMOTE_CANCEL_UNREAD -> "INCOMING_FT_REMOTE_CANCEL_UNREAD"
        INCOMING_FT_REMOTE_CANCEL_READ -> "INCOMING_FT_REMOTE_CANCEL_READ"
        INCOMING_FT_UNKNOWN_ERROR_UNREAD -> "INCOMING_FT_UNKNOWN_ERROR_UNREAD"
        INCOMING_FT_UNKNOWN_ERROR_READ -> "INCOMING_FT_UNKNOWN_ERROR_READ"
        INCOMING_FT_RECEIVED_CHECKED_UNREAD -> "INCOMING_FT_RECEIVED_CHECKED_UNREAD"
        INCOMING_FT_RECEIVED_CHECKED_READ -> "INCOMING_FT_RECEIVED_CHECKED_READ"

        INCOMING_IMAGE_TRANSFER_RECEIVED_UNREAD -> "INCOMING_IMAGE_TRANSFER_RECEIVED_UNREAD"
        INCOMING_IMAGE_TRANSFER_RECEIVED_READ -> "INCOMING_IMAGE_TRANSFER_RECEIVED_READ"
        else -> "UNKNOWN_STATUS"
    }
}
