package com.bria.common.controller.im.refactoring.filetransfer

import android.support.annotation.IntDef
import com.bria.common.controller.im.refactoring.db.entities.ImConversationData
import com.bria.common.controller.im.refactoring.db.entities.InstantMessageData
import com.counterpath.sdk.XmppFileTransfer


data class FileTransferInfo(var imConversationData: ImConversationData,
                             var fileTransfer: XmppFileTransfer,
                             var messages: HashMap<Int, InstantMessageData>,
                             var state: Int,
                             val retries: Int,
                             var fullRemoteAddress : String?) {

    companion object {

        @IntDef(PENDING, SENDING, RECEIVING, SENT, FAILED_TO_SENT, RECEIVE, FAILED_TO_RECEIVE, REJECTED)
        @Retention(AnnotationRetention.SOURCE)
        annotation class FileTransferState

        const val PENDING = 0
        const val SENDING = 1
        const val RECEIVING = 2
        const val SENT = 3
        const val FAILED_TO_SENT = 4
        const val RECEIVE = 5
        const val FAILED_TO_RECEIVE = 6
        const val REJECTED = 7
    }
}
