package com.bria.common.controller.im.util

import android.text.Html
import com.bria.common.controller.im.refactoring.db.entities.InstantMessageData
import com.bria.common.util.MimeTypes
import kotlin.math.abs

/**
 * For the lack of a better name.
 * */
object ImHelper {
    /**
     * @param contentType one of the MIME types
     */
    fun processIncomingMessage(incomingMessage: String?, contentType: String?): String {
        if (incomingMessage.isNullOrEmpty()) {
            return ""
        }

        if (contentType.equals(MimeTypes.TEXT_HTML, true)) {
            val body = Html.fromHtml(incomingMessage)
            return body.toString()
        }

        return incomingMessage ?: ""
    }

    /**
     * Tries to detect duplicate message, for cases when messages comes both thru SIP channel and via push.
     * We are forced to do simple comparison like this because there is no unique message id.
     * */
    fun isDuplicate(message1: InstantMessageData?, message2: InstantMessageData?): Boolean {
        if (message1 == null && message2 == null) {
            return true
        }

        if (message1 == null && message2 != null) {
            return false
        }

        if (message1 != null && message2 == null) {
            return false
        }

        var result = message1!!.message == message2!!.message

        val timeDifferenceThreshold = 200 //ms
        result = result && abs(message1.time - message2.time) < timeDifferenceThreshold

        return result
    }
}
