package com.bria.common.controller.phone

import io.reactivex.Observable
import io.reactivex.subjects.BehaviorSubject

object CallQualityObservable {
    private val mSubject = BehaviorSubject.createDefault(CallQuality.Unknown)

    @JvmStatic
    fun getObservable(): Observable<CallQuality> {
        return mSubject
            // don't fire if it's the same quality
            .distinctUntilChanged()
    }

    @JvmStatic
    fun getCurrentValue(): CallQuality {
        return mSubject.value!!
    }

    @JvmStatic
    fun publishValue(callQuality: CallQuality) {
        mSubject.onNext(callQuality)
    }
}
