package com.bria.common.controller.phone

import io.reactivex.Observable
import io.reactivex.subjects.PublishSubject

object GoodCallQualityProvenObservable {
    enum class CallQuality {
        Proven,
        NotProven
    }

    private val mPublishSubject = PublishSubject.create<CallQuality>()

    @JvmStatic
    fun getObservable(): Observable<CallQuality> {
        return mPublishSubject
    }

    @JvmStatic
    fun publishValue(callQuality: CallQuality) {
        mPublishSubject.onNext(callQuality)
    }
}
