package com.bria.common.customelements.internal.views.buttons

import com.bria.common.controller.settings.ESetting

/**
 * Helper class used to store the allowed set of colors for the [TwoStateImageView].
 *
 * **Note**: Be sure to modify `attrs_two_state_image_view.xml` if you change the order of settings in this file.
 */
object AllowedColors {

    /**
     * A list of allowed color settings for the [TwoStateImageView].
     */
    val SETTINGS = arrayOf(
            ESetting.ColorBrandDefault,
            ESetting.ColorBrandTint,
            ESetting.ColorSelection,
            ESetting.ColorTabBar,
            ESetting.ColorTabBarSelection,
            ESetting.ColorNavBar,
            ESetting.ColorAuxNavBar,
            ESetting.ColorSearchBar,
            ESetting.ColorSegControl,
            ESetting.ColorTabNormal,
            ESetting.ColorTabSelected,
            ESetting.ColorPhoneCall,
            ESetting.ColorPhoneNumberBackground,
            ESetting.ColorPhoneNumberText,
            ESetting.ColorPhoneBackground,
            ESetting.ColorPhoneBackgroundExt,
            ESetting.ColorPhoneBackgroundDividers,
            ESetting.ColorPhoneText,
            ESetting.ColorPhoneSelection,
            ESetting.ColorCallKeypadBackground,
            ESetting.ColorCallText,
            ESetting.ColorCallBackground,
            ESetting.ColorAboutText,
            ESetting.ColorCallSelection,
            ESetting.ColorFilterIcon,
            ESetting.ColorBlack,
            ESetting.ColorLtGray,
            ESetting.ColorDkGary,
            ESetting.ColorWhite,
            ESetting.ColorTransparent,
            ESetting.ColorHangup,
            ESetting.ColorTabIcon,
            ESetting.ColorCallNavBar
    )

}
