package com.bria.common.customelements.internal.views.buttons

import android.os.Parcel
import android.os.Parcelable
import android.view.View

/**
 * A special state class used to store the [TwoStateImageView]'s state in a parcelable container.
 */
class TwoStateImageViewState : View.BaseSavedState {

    companion object {
        @JvmStatic // required field that makes Parcelables from a Parcel
        val CREATOR: Parcelable.Creator<TwoStateImageViewState> = object : Parcelable.Creator<TwoStateImageViewState> {
            override fun createFromParcel(`in`: Parcel): TwoStateImageViewState = TwoStateImageViewState(`in`)
            override fun newArray(size: Int): Array<TwoStateImageViewState?> = arrayOfNulls(size)
        }
    }

    var isActive: Boolean = false

    constructor(superState: Parcelable) : super(superState)

    private constructor(input: Parcel) : super(input) {
        isActive = input.readByte().toInt() == 1
    }

    override fun writeToParcel(out: Parcel, flags: Int) {
        super.writeToParcel(out, flags)
        out.writeByte((if (isActive) 1 else 0).toByte())
    }

}
