package com.bria.common.modules

import com.bria.common.controller.settings.core.utils.SettingsStringEncoder
import kotlin.concurrent.thread

object InitializerForSlowComponentsNeededEarly {

    @JvmStatic
    fun initialize() {
        thread(
                // true is default, but just to be explicit
                start = true,

                // don't prevent shutdown
                // if `true`, the thread is created as a daemon thread. The Java Virtual Machine exits when the only threads running are all daemon threads.
                isDaemon = true,

                // nice to see in profiler
                name = "InitializerForSlowComponentsNeededEarly") {

            // class init
            SettingsStringEncoder.touch()
        }
    }
}
