package com.bria.common.modules.android

import android.app.Application
import com.bria.common.util.Utils

class AppLifetimeReceivers(
        private val application: Application,
        private val backgroundForegroundScreenOffReceiver: BackgroundForegroundScreenOffReceiver) {

    private val LOG_TAG = "AppLifetimeReceivers"

    fun register() {
        application.registerReceiver(backgroundForegroundScreenOffReceiver, BackgroundForegroundScreenOffReceiver.intentFilter)
    }

    fun unregister() {
        try {
            application.unregisterReceiver(backgroundForegroundScreenOffReceiver)
        } catch (throwable: Throwable) {
            Utils.crashInDebug(LOG_TAG, throwable)
        }
    }
}
