package com.bria.common.modules.android

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import com.bria.common.util.Log

class BackgroundForegroundScreenOffReceiver : BroadcastReceiver() {
    private val LOG_TAG = "BackgroundForegroundScreenOffReceiver"

    companion object {
        val intentFilter: IntentFilter = IntentFilter(Intent.ACTION_SCREEN_OFF) // Sent when the device goes to sleep and becomes non-interactive.
    }

    override fun onReceive(context: Context?, intent: Intent?) {
        Log.d(LOG_TAG, "Screen turning off: onReceive(ACTION_SCREEN_OFF)")

        BackgroundOrForegroundObservable.notify(BackgroundOrForegroundState.Background)
    }
}
