package com.bria.common.modules.android

import com.bria.common.util.Log
import io.reactivex.Observable
import io.reactivex.subjects.PublishSubject

object BackgroundOrForegroundObservable {
    private val LOG_TAG = "BackgroundOrForegroundObservable"

    // starts as background in order to be notified on first launch
    private var mCurrentState = BackgroundOrForegroundState.Background

    private val mObservable: PublishSubject<BackgroundOrForegroundState> = PublishSubject.create()

    fun notify(currentState: BackgroundOrForegroundState) {
        Log.i(LOG_TAG, "App is in: $mCurrentState, new state: $currentState")

        if (mCurrentState != currentState) {
            mObservable.onNext(currentState)
            mCurrentState = currentState
        }
    }

    val observable: Observable<BackgroundOrForegroundState>
        get() = mObservable

    val currentState: BackgroundOrForegroundState
        get() = mCurrentState
}
