package com.bria.common.modules.android

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import com.bria.common.modules.ModuleClassFinder
import com.bria.common.util.AndroidUtils
import com.bria.common.util.GlobalConstants
import com.bria.common.util.Log

class BrandableCallActionReceiver : BroadcastReceiver() {

    companion object {
        private val TAG = "BrandableCallActionReceiver"
    }

    override fun onReceive(context: Context, intent: Intent?) {
        val action = intent?.action
        val brandableIntentActionCall = "${context.packageName}.action.CALL"
        if (action == brandableIntentActionCall) {
            Log.d(TAG, "onReceive() matched action: $action")
            val className = ModuleClassFinder.instance.serviceClass.name
            Log.d(TAG, "onReceive() calling startService, package: ${context.packageName}, class: $className")
            intent.setClass(context, ModuleClassFinder.instance.serviceClass)
            intent.putExtra(GlobalConstants.EXTRA_INTENT_SOURCE, "$TAG#1 source=$this")
            AndroidUtils.startServiceCompat(context, intent) // this will cause BriaVoipService.onStartCommand() to be called
        }
    }

}
