package com.bria.common.modules.android

import android.annotation.SuppressLint
import android.content.Context
import android.os.PowerManager
import com.bria.common.util.Log

object IncomingCallWakeLock {
    private val TAG = "IncomingCallWakeLock"

    private var mIncomingCallWakeLock: PowerManager.WakeLock? = null

    @SuppressLint("WakelockTimeout")
// ensure processor is working hard, so the app is not suspended mid startup during push call
    fun turnProcessorUpToEleven(context: Context, indefinite: Boolean = false) {
        if (mIncomingCallWakeLock == null) {
            val powerManager = context.getSystemService(Context.POWER_SERVICE) as PowerManager?
            mIncomingCallWakeLock = powerManager!!.newWakeLock(PowerManager.SCREEN_BRIGHT_WAKE_LOCK or PowerManager.ACQUIRE_CAUSES_WAKEUP, javaClass.name)
        }
        if (mIncomingCallWakeLock!!.isHeld()) {
            releaseWakeLock()
        }
        if (indefinite) {
            mIncomingCallWakeLock!!.acquire()
        } else {
            mIncomingCallWakeLock!!.acquire(1 * 60 * 1000L)
        }
    }

    fun releaseWakeLock() {
        if (mIncomingCallWakeLock == null) {
            Log.d(TAG, "BriaApplication wakeLock is null")
        }

        if (mIncomingCallWakeLock!!.isHeld) {
            Log.d(TAG, "Releasing BriaApplication wakeLock")
            mIncomingCallWakeLock!!.release()
        } else {
            Log.d(TAG, "BriaApplication wakeLock is not held")
        }
    }
}

