package com.bria.common.modules.annotations

import android.support.annotation.IntDef
import com.bria.common.modules.framework.ComponentLifecycle

/**
 * Marker annotation for all [ComponentLifecycle] states. Possible constants:
 * - [ComponentLifecycle.STATE_NONE]
 * - [ComponentLifecycle.STATE_CREATING]
 * - [ComponentLifecycle.STATE_CREATE_STEP]
 * - [ComponentLifecycle.STATE_CREATED]
 * - [ComponentLifecycle.STATE_DESTROYING]
 * - [ComponentLifecycle.STATE_DESTROY_STEP]
 * - [ComponentLifecycle.STATE_DESTROYED]
 */
@IntDef(ComponentLifecycle.STATE_NONE, ComponentLifecycle.STATE_CREATING, ComponentLifecycle.STATE_CREATE_STEP,
        ComponentLifecycle.STATE_CREATED, ComponentLifecycle.STATE_DESTROYING, ComponentLifecycle.STATE_DESTROY_STEP,
        ComponentLifecycle.STATE_DESTROYED)
@Retention(AnnotationRetention.SOURCE)
annotation class LifecycleState
