package com.bria.common.modules.annotations

import android.support.annotation.IntDef
import com.bria.common.modules.framework.ComponentLifecycle

/**
 * Marker annotation for [ComponentLifecycle] step states. Possible constants:
 * - [ComponentLifecycle.STATE_CREATE_STEP]
 * - [ComponentLifecycle.STATE_DESTROY_STEP]
 */
@IntDef(ComponentLifecycle.STATE_CREATE_STEP, ComponentLifecycle.STATE_DESTROY_STEP)
@Retention(AnnotationRetention.SOURCE)
annotation class LifecycleStep
