package com.bria.common.modules.meta

/**
 * Serves as a single list of all component IDs.
 */
// please comment if it's unclear which component you are referring to
// we use boolean markers to be able to mask bits later
object ComponentIds {

    /**
     * Main, application context
     */
    const val APP_CONTEXT = 0b000000000000000000000001

    /**
     * SIP Stack Manager instance
     */
    const val STACK_MANAGER = 0b000000000000000000000010

    /**
     * CPC API instance
     */
    const val CPCAPI2 = 0b000000000000000000000100

    /**
     * Main controller instance
     */
    const val CONTROLLER = 0b000000000000000000001000

    /**
     * Main controller's #onReady() block
     */
    const val CONTROLLER_INIT = 0b100000000000000000001000

    /**
     * Main service
     */
    const val SERVICE_MAIN = 0b010000000000000000010000
}
