package com.bria.common.network

import io.reactivex.Observable
import io.reactivex.subjects.PublishSubject

object ConnectivityObservable {
    private val mPublishSubject = PublishSubject.create<ConnectivityEvent>()

    @JvmStatic
    fun getObservable(): Observable<ConnectivityEvent> {
        return mPublishSubject
    }

    @JvmStatic
    fun notifyNewValue(connectivityEvent: ConnectivityEvent) {
        mPublishSubject.onNext(connectivityEvent)
    }
}
