package com.bria.common.permission

import io.reactivex.Observable
import io.reactivex.subjects.PublishSubject

object PermissionsObservable {
    private val mPublishSubject = PublishSubject.create<Permission>()

    fun getObservable(): Observable<Permission> {
        return mPublishSubject
    }

    fun notify(requestCode: Int, permissions: Array<String>, grantResults: IntArray) {
        for (i in permissions.indices) {
            val permission = permissions[i]
            val grantResult = grantResults[i]
            val granted = grantResult == android.content.pm.PackageManager.PERMISSION_GRANTED

            mPublishSubject.onNext(Permission(requestCode, permission, granted))
        }
    }

    data class Permission(
            val requestCode: Int,
            val permission: String,
            val granted: Boolean)
}
