package com.bria.common.tapi

import android.content.ComponentName
import android.content.Context
import android.content.Intent
import android.net.Uri
import android.widget.Toast

object CallWithOtherThanBria {
    @JvmStatic
    fun dialWithoutChooser(context: Context, number: String) {
        val uri = Uri.fromParts("tel", number, null)
        val intent = Intent(Intent.ACTION_DIAL, uri)
        intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK

        val intentActivities = context.packageManager.queryIntentActivities(intent, 0)

        val resolveInfo = intentActivities
            .filter { it.activityInfo.exported }
            .filter { it.activityInfo.enabled }
            .filter { !it.activityInfo.name.contains("bria", true) }
            .firstOrNull()

        if (resolveInfo != null) {
            val activityInfo = resolveInfo.activityInfo
            intent.component = ComponentName(activityInfo.applicationInfo.packageName, activityInfo.name)

            context.startActivity(intent)
        } else {
            Toast.makeText(context, "Sorry, no available apps for dialing $number", Toast.LENGTH_LONG)
        }
    }
}
