package com.bria.common.teams

import com.bria.common.controller.accounts.Account
import com.bria.common.controller.accounts.IAccountsCtrlActions
import com.bria.common.controller.contacts.buddy.Buddy
import com.bria.common.controller.settings.EAccountSetting
import com.bria.common.controller.settings.branding.EAccountType

class TeamsModule(private val accountsCtrl: IAccountsCtrlActions) {
    val teamAccount: Account?
        get() = accountsCtrl
            .accounts
            .filter { it.type == EAccountType.Xmpp }
            .firstOrNull { it.getBool(EAccountSetting.Hardwired) }

    fun isBuddyFromTeam(buddy: Buddy?): Boolean {
        if (buddy == null) {
            return false
        }

        if (buddy.accountNickname.isNullOrEmpty()) {
            return false
        }

        val teamAccountLocal = teamAccount;
        if (teamAccountLocal == null) {
            return false
        }

        return buddy.accountNickname == teamAccountLocal.getStr(EAccountSetting.Nickname);
    }
}
