package com.bria.common.ui.util

import android.view.View

class ExpandableAreaController(private val expandSymbol: View, private val expandedArea: View, callback: (isExpanded: Boolean) -> Unit) {
    init {
        expandSymbol.setOnClickListener { v ->
            if (expandedArea.getVisibility() == View.VISIBLE) {
                expandedArea.setVisibility(View.GONE)
                expandSymbol.animate().rotation(0f)
                callback(false)
            } else {
                expandedArea.setVisibility(View.VISIBLE)
                expandSymbol.animate().rotation(180f)
                callback(true)
            }
        }
    }

    fun setExpanded(isExpanded: Boolean) {
        if (isExpanded) {
            expandedArea.visibility = View.VISIBLE
            expandSymbol.rotation = 180f
        } else {
            expandedArea.visibility = View.GONE
            expandSymbol.rotation = 0f
        }
    }
}
