package com.bria.common.ui.util

import android.text.SpannableStringBuilder
import android.text.style.ForegroundColorSpan
import android.widget.TextView

class SearchQueryColorizer(highlightColor: Int) {

    private val mForegroundColorSpan: ForegroundColorSpan = ForegroundColorSpan(highlightColor)

    fun colorize(textView: TextView, queryTokens: List<String>) {
        val text = textView.text.toString()

        if(text.isBlank()){
            return
        }

        for (queryToken in queryTokens) {
            if (queryToken.isBlank()) {
                // should not happen, but...
                continue
            }

            val index = text.toLowerCase().indexOf(queryToken.toLowerCase())
            if (index == 0 || index > 0 && text[index - 1].isWhitespace()) {
                val spannableStringBuilder = SpannableStringBuilder(text)
                spannableStringBuilder.setSpan(mForegroundColorSpan, index, index + queryToken.length, 0)

                textView.text = spannableStringBuilder

                // one colorization is enough, perhaps
                return
            }
        }
    }
}
