package com.bria.common.uireusable.dataprovider

class FilterQueryMatcher(query: String?) {
    val queryTokens = tokenize(query ?: "")

    fun isMatch(vararg stringsToMatch: String): Boolean {
        val nameTokens = stringsToMatch.flatMap { tokenize(it) }

        for (q in queryTokens) {
            for (name in nameTokens) {
                if (name.startsWith(q)) {
                    return true
                }
            }
        }

        return false
    }

    private fun tokenize(string: String?): List<String> {
        if (string == null) {
            return listOf()
        }

        return string
            .toLowerCase()
            .split("\\s+".toRegex())
            .filter { it.isNotEmpty() }
    }
}
