package com.bria.common.util

// Guava, please...
class Optional<T : Any> {
    private var mInnerValue: T? = null
    val hasValue: Boolean

    private constructor(innerValue: T) {
        mInnerValue = innerValue
        hasValue = true
    }

    private constructor() {
        hasValue = false
    }

    val value: T
        get() = mInnerValue ?: throw IllegalStateException()

    override fun toString(): String {
        return if (hasValue)
            mInnerValue.toString()
        else
            "missing"
    }

    companion object {
        @JvmStatic
        fun <T : Any> fromNullable(value: T?): Optional<T> {
            if (value == null)
                return Optional<T>()

            return Optional(value!!)
        }

        @JvmStatic
        fun <T : Any> strict(value: T): Optional<T> {
            return Optional(value)
        }

        @JvmStatic
        fun <T : Any> missing(): Optional<T> {
            return Optional()
        }
    }
}
