@file:Suppress("unused")

package com.bria.common.util.kotlin

import android.view.View
import android.view.View.*

// <editor-fold desc="Visibility getters">
/**
 * Checks if current view is visible.
 * @return `True` if `this.visibility == VISIBLE`, `false` otherwise
 */
fun View.isVisible() = this.visibility == VISIBLE

/**
 * Checks if current view is invisible.
 * @return `True` if `this.visibility == INVISIBLE`, `false` otherwise
 */
fun View.isInvisible() = this.visibility == INVISIBLE

/**
 * Checks if current view is gone.
 * @return `True` if `this.visibility == GONE`, `false` otherwise
 */
fun View.isGone() = this.visibility == GONE
// </editor-fold>

// <editor-fold desc="Visibility setters">
/**
 * Sets the current View's visibility to [VISIBLE].
 */
fun View.setVisible() {
    this.visibility = VISIBLE
}

/**
 * Sets the current View's visibility to [INVISIBLE].
 */
fun View.setInvisible() {
    this.visibility = INVISIBLE
}

/**
 * Sets the current View's visibility to [GONE].
 */
fun View.setGone() {
    this.visibility = GONE
}
// </editor-fold>
