package com.bria.common.util.reactive.impl

import com.bria.common.util.reactive.api.SchedulerProvider
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import io.reactivex.schedulers.TestScheduler

/**
 * A production variant of the [SchedulerProvider]. Returns normal schedulers from the [Schedulers] group.
 */
class SchedulerProviderProduction : SchedulerProvider {
    override fun io() = Schedulers.io()
    override fun computation() = Schedulers.computation()
    override fun main() = AndroidSchedulers.mainThread()!!
    override fun test() = TestScheduler()
}
