package com.bria.voip.ui.call.presenters

import com.bria.common.controller.Controllers
import com.bria.common.controller.phone.callsapi.CallInfo
import com.bria.common.controller.settings.branding.CustomQuickStartMenuItem
import com.bria.voip.ui.main.dialer.quickstart.QuickStartCustomItemsProvider

object AbstractCallPresenterHelper {
    private val LOG_TAG = "AbstractCallPresenterHelper"

    fun isActiveCallToOneOfCustomQuickStartItemsWithDtmf(callInfo: CallInfo): Boolean {
        val quickStartCustomItemsProvider = QuickStartCustomItemsProvider(Controllers.get().settings)
        val customQuickStartItems = quickStartCustomItemsProvider.getCustomQuickStartItems()

        return isActiveCallToOneOfCustomQuickStartItemsWithDtmf(callInfo.state, callInfo.remoteUser, customQuickStartItems)
    }

    fun isActiveCallToOneOfCustomQuickStartItemsWithDtmf(
            callState: CallInfo.ECallState,
            phoneNumber: String,
            customQuickStartMenuItems: Iterable<CustomQuickStartMenuItem>)
            : Boolean {

        if (callState != CallInfo.ECallState.ACTIVE) {
            return false
        }

        return customQuickStartMenuItems
            .filter { it.showDtmf }
            .filter { it.code == phoneNumber }
            .any()
    }
}
