package com.bria.voip.ui.call.presenters

import android.support.annotation.ColorRes
import android.support.annotation.DrawableRes
import android.support.annotation.StringRes
import com.bria.common.controller.phone.CallQuality
import com.bria.common.util.Utils
import com.bria.voip.R

class CallQualityUiAssets(@DrawableRes val drawable: Int, @ColorRes val color: Int, @StringRes val label: Int) {

    companion object {
        private val LOG_TAG = "CallQualityUiAssets"

        private val map = mapOf(
                CallQuality.Unknown to CallQualityUiAssets(R.drawable.ic_connectionhealth_unknown, R.color.call_quality_unknown, R.string.tCallQualityUnknown),
                CallQuality.Good to CallQualityUiAssets(R.drawable.ic_connectionhealth_good, R.color.call_quality_good, R.string.tCallQualityGood),
                CallQuality.Fair to CallQualityUiAssets(R.drawable.ic_connectionhealth_fair, R.color.call_quality_fair, R.string.tCallQualityFair),
                CallQuality.Poor to CallQualityUiAssets(R.drawable.ic_connectionhealth_poor, R.color.call_quality_poor, R.string.tCallQualityPoor)
        )

        @JvmStatic
        fun findAssets(callQuality: CallQuality): CallQualityUiAssets {
            val uiAssets = map.get(callQuality)
            if (uiAssets == null) {
                Utils.crashInDebug(LOG_TAG, "Unknown callQuality value: $callQuality")

                return map.getValue(CallQuality.Unknown)
            }

            return uiAssets
        }
    }

}
