package com.bria.voip.ui.main.contacts

import android.graphics.Typeface
import android.widget.TextView
import com.bria.common.controller.contacts.ContactsSortBy

object ContactUiHelper {
    fun signifySortOrderWithTypeface(firstName: TextView, lastName: TextView, sortBy: ContactsSortBy) {
        if (firstName.text.isNullOrEmpty() || lastName.text.isNullOrEmpty()) {
            // No bold text here - design choice - first mentioned in r81618
            firstName.setTypeface(firstName.typeface, Typeface.NORMAL)
            lastName.setTypeface(lastName.typeface, Typeface.NORMAL)
        } else {
            if (sortBy == ContactsSortBy.FirstName) {
                firstName.setTypeface(firstName.typeface, Typeface.BOLD)
                lastName.setTypeface(lastName.typeface, Typeface.NORMAL)
            } else {
                firstName.setTypeface(firstName.typeface, Typeface.NORMAL)
                lastName.setTypeface(lastName.typeface, Typeface.BOLD)
            }
        }
    }
}
