package com.bria.voip.ui.main.dialer.quickstart

import com.bria.common.controller.settings.ESetting
import com.bria.common.controller.settings.ISettingsReader
import com.bria.common.controller.settings.branding.CustomQuickStartMenuItem
import java.util.*

class QuickStartCustomItemsProvider(val settingsReader: ISettingsReader<ESetting>) {

    fun getCustomQuickStartItems(): List<CustomQuickStartMenuItem> {
        if (!settingsReader.getBool(ESetting.FeatureCustomQuickStartMenu)) {
            return ArrayList()
        }

        var list: List<CustomQuickStartMenuItem>? = settingsReader.getList(ESetting.CustomQuickStartMenuItems, CustomQuickStartMenuItem::class.java)
        if (list == null) {
            list = ArrayList()
        }

        // debug
//        list = listOf(
//                CustomQuickStartMenuItem("Park 1", "*65401", false, null),
//                CustomQuickStartMenuItem("Park 2", "*65403", false, "dialpad"),
//                CustomQuickStartMenuItem("Park 3", "*65403", false, "megaphone"),
//                CustomQuickStartMenuItem("Paging", "*11", false, "abc"),
//                CustomQuickStartMenuItem("Speed Dial", "1218", false, "phone_with_arrow")
//        )

        val result = list
                // The system shall support up to 5 values.
            .take(5)

                // If any part of the setting is missing, such command is set but text is not, then the app should ignore the value.
            .filter { !it.code.isNullOrBlank() }
            .filter { !it.displayText.isNullOrBlank() }

                //If for example if Option 1 and Option 3 are set, and Option 2 is null, then option3 should appear above option 2 without a gap.
            .reversed()


        return result
    }
}
