package com.bria.voip.ui.main.im

import com.bria.common.controller.accounts.IAccountsCtrlActions
import com.bria.common.controller.accounts.IAccountsCtrlObserver
import com.bria.common.controller.license.ILicenseCtrlActions
import com.bria.common.controller.presence.IPresenceCtrlEvents
import com.bria.common.controller.presence.PresenceStatuses
import com.bria.common.controller.presence.refactoring.EPresenceStatus
import com.bria.common.controller.settings.core.Settings
import com.bria.common.modules.BriaGraph
import com.bria.common.uireusable.dataprovider.ISimpleDataProvider
import com.bria.common.util.IObservable

class ImStatusChangePresenterDependencies {

    // still lazy
    val presenceStatuses: PresenceStatuses
        get() = BriaGraph.presenceStatuses

    val presenceDataProvider: ISimpleDataProvider<EPresenceStatus>
        get() = BriaGraph.presenceDataProvider

    val settings: Settings
        get() = BriaGraph.settings

    val accountsController: IAccountsCtrlActions
        get() = BriaGraph.accountsController

    val accountsObservable: IObservable<IAccountsCtrlObserver>
        get() = BriaGraph.accountsObservable

    val licenseController: ILicenseCtrlActions
        get() = BriaGraph.licenseController

    val presenceController: IPresenceCtrlEvents
        get() = BriaGraph.presenceController
}
