package com.bria.voip.ui.main.im.chatroom

import com.bria.common.controller.Controllers
import com.bria.common.controller.contacts.ContactsSortBy
import com.bria.common.controller.contacts.buddy.Buddy
import com.bria.common.controller.im.ImpsUtils
import com.bria.common.controller.im.refactoring.BuddyKeyUtils
import com.bria.common.controller.settings.ESetting
import com.bria.common.controller.settings.branding.EAccountType
import com.bria.common.controller.settings.core.Settings
import com.bria.common.uiframework.presenters.AbstractPresenter
import com.bria.common.uiframework.presenters.IPresenterEventTypeEnum
import com.bria.voip.R
import io.reactivex.disposables.CompositeDisposable

class ChatRoomMembersPresenter : AbstractPresenter() {


    val settings get() = Settings.get(context)

    val dataProvider = ChatRoomMembersDataProvider(
            Controllers.get().buddy,
            ContactsSortBy.fromRawIntValue(settings.getInt(ESetting.ContactSortOrder)))

    var disposable = CompositeDisposable()

    enum class Events : IPresenterEventTypeEnum {
        BZZZ;

        override fun getType(): IPresenterEventTypeEnum = this
    }

    var title: String = getString(R.string.tChatRoomMembers)
    var adapterState = ChatRoomMembersAdapter.State()
    var mChatRoomId: Long = -1

    fun init(chatRoomId: Long) {
        // find chat room by id
        // take members from it

        val account = Controllers.get().accounts.getAccount("acc_0")
        val userAtDomain = ImpsUtils.getUserAtDomainForAccount(account)

        var buddyKeys = setOf(
                BuddyKeyUtils.getNewBuddyKey(EAccountType.Xmpp, userAtDomain, "malipera3@188.166.66.116"),
                BuddyKeyUtils.getNewBuddyKey(EAccountType.Xmpp, userAtDomain, "malipera1@188.166.66.116"),
                BuddyKeyUtils.getNewBuddyKey(EAccountType.Xmpp, userAtDomain, "malipera5@188.166.66.116")
        )

        if (mChatRoomId != chatRoomId) {
            adapterState = ChatRoomMembersAdapter.State()
        }

        dataProvider.setBuddyKeys(buddyKeys)
    }

    fun sendMessageTo(buddy: Buddy) {

    }

    fun removeFromChatRoom(buddy: Buddy) {

    }

    fun filterBy(searchString: String?) {
        dataProvider.filter(searchString)
    }
}
