package com.bria.voip.ui.main.settings.developer.settings2

import android.support.v7.widget.RecyclerView
import android.view.View
import android.widget.TextView
import com.bria.common.uiframework.lists.recycler.AbstractRecyclerAdapter
import com.bria.voip.R

class SettingsViewerAdapter(recycler: RecyclerView, layout: Int) : AbstractRecyclerAdapter<SettingsViewerPresenter.SettingsViewerListItem,
        SettingsViewerAdapter.ViewHolder>(recycler, layout) {

    class ViewHolder(itemView: View) : AbstractRecyclerAdapter.AbstractViewHolder(itemView) {
        val name: TextView = itemView.findViewById(R.id.settings_viewer_list_item_name)
        val type: TextView = itemView.findViewById(R.id.settings_viewer_list_item_type)
        val value: TextView = itemView.findViewById(R.id.settings_viewer_list_item_value)
    }

    override fun provideNewViewHolder(inflatedView: View, viewType: Int) = ViewHolder(inflatedView)
    override fun onNewViewHolderReady(viewHolder: ViewHolder?, viewType: Int) {}

    override fun onUpdateNeeded(viewHolder: ViewHolder, position: Int) {
        val item = dataProvider?.getItemAt(position)
        viewHolder.name.text = item?.name
        viewHolder.type.text = item?.type
        viewHolder.value.text = item?.value
    }


}
